Index: /NEMO/branches/2019/dev_ASINTER-01-05_merged/src/ABL/ablmod.F90
===================================================================
--- /NEMO/branches/2019/dev_ASINTER-01-05_merged/src/ABL/ablmod.F90	(revision 12014)
+++ /NEMO/branches/2019/dev_ASINTER-01-05_merged/src/ABL/ablmod.F90	(revision 12015)
@@ -17,6 +17,7 @@
    USE phycst         ! physical constants
    USE dom_oce, ONLY  : tmask  
-   USE sbc_oce, ONLY  : ght_abl, ghw_abl, e3t_abl, e3w_abl, jpka, jpkam1
-   USE sbcblk         ! use some physical constants for flux computation
+   USE sbc_oce, ONLY  : ght_abl, ghw_abl, e3t_abl, e3w_abl, jpka, jpkam1, rhoa
+   USE sbcblk         ! use rn_?fac
+   USE sbcblk_phy     ! use some physical constants for flux computation
    !
    USE prtctl         ! Print control                    (prt_ctl routine)
@@ -100,6 +101,6 @@
       REAL(wp) , INTENT(  out), DIMENSION(:,:  ) ::   ptauj_ice    ! ice-surface tauy stress (V-point) 	  
 #endif	  
-	  !
-      REAL(wp), DIMENSION(1:jpi,1:jpj   )        ::   zrhoa, zwnd_i, zwnd_j
+      !
+      REAL(wp), DIMENSION(1:jpi,1:jpj   )        ::   zwnd_i, zwnd_j
       REAL(wp), DIMENSION(1:jpi,2:jpka  )        ::   zCF    
       REAL(wp), DIMENSION(1:jpi,1:jpj,1:jpka)    ::   z_cft      !--FL--to be removed after the test phase   
@@ -529,9 +530,10 @@
             ztemp             = tq_abl  ( ji, jj, 2, nt_a, jp_ta ) 
             zhumi             = tq_abl  ( ji, jj, 2, nt_a, jp_qa ) 
-            zcff              = pslp_dta( ji, jj ) /   &              !<-- At this point ztemp and zhumi should not be zero ...
-               &                        (  R_dry*ztemp * ( 1._wp + rctv0*zhumi )  )
+            !zcff              = pslp_dta( ji, jj ) /   &              !<-- At this point ztemp and zhumi should not be zero ...
+            !   &                        (  R_dry*ztemp * ( 1._wp + rctv0*zhumi )  )
+            zcff              = rho_air( ztemp, zhumi, pslp_dta( ji, jj ) )
             psen ( ji, jj )   =      cp_air(zhumi) * zcff * psen(ji,jj) * ( psst(ji,jj) + rt0 - ztemp )
             pevp ( ji, jj )   = rn_efac*MAX( 0._wp,  zcff * pevp(ji,jj) * ( pssq(ji,jj)       - zhumi ) )
-            zrhoa( ji, jj )   = zcff              
+            rhoa( ji, jj )   = zcff              
          END DO
       END DO
@@ -551,5 +553,5 @@
             zcff          = SQRT(  zwnd_i(ji,jj) * zwnd_i(ji,jj)   &
                &                 + zwnd_j(ji,jj) * zwnd_j(ji,jj)  )  ! * msk_abl(ji,jj)
-            zztmp         = zrhoa(ji,jj) * pcd_du(ji,jj)
+            zztmp         = rhoa(ji,jj) * pcd_du(ji,jj)
             
             pwndm (ji,jj) =         zcff
@@ -593,9 +595,9 @@
                zztmp2 = 0.5_wp * ( v_abl(ji,jj+1,2,nt_a) + v_abl(ji,jj,2,nt_a) )
 			   
-               ptaui_ice(ji,jj) = 0.5_wp * (  zrhoa(ji+1,jj) * pCd_du_ice(ji+1,jj)             &
-                  &                      +    zrhoa(ji  ,jj) * pCd_du_ice(ji  ,jj)  )          &
+               ptaui_ice(ji,jj) = 0.5_wp * (  rhoa(ji+1,jj) * pCd_du_ice(ji+1,jj)             &
+                  &                      +    rhoa(ji  ,jj) * pCd_du_ice(ji  ,jj)  )          &
                   &         * ( zztmp1 - rn_vfac * pssu_ice(ji,jj) )
-               ptauj_ice(ji,jj) = 0.5_wp * (  zrhoa(ji,jj+1) * pCd_du_ice(ji,jj+1)             &
-                  &                      +    zrhoa(ji,jj  ) * pCd_du_ice(ji,jj  )  )          &
+               ptauj_ice(ji,jj) = 0.5_wp * (  rhoa(ji,jj+1) * pCd_du_ice(ji,jj+1)             &
+                  &                      +    rhoa(ji,jj  ) * pCd_du_ice(ji,jj  )  )          &
                   &         * ( zztmp2 - rn_vfac * pssv_ice(ji,jj) )
             END DO
Index: /NEMO/branches/2019/dev_ASINTER-01-05_merged/src/ABL/sbcabl.F90
===================================================================
--- /NEMO/branches/2019/dev_ASINTER-01-05_merged/src/ABL/sbcabl.F90	(revision 12014)
+++ /NEMO/branches/2019/dev_ASINTER-01-05_merged/src/ABL/sbcabl.F90	(revision 12015)
@@ -341,4 +341,5 @@
          &                tq_abl(:,:,2,nt_n,jp_ta), tq_abl(:,:,2,nt_n,jp_qa),   &   !   <<= in
          &                sf(jp_slp )%fnow(:,:,1) , sst_m, ssu_m, ssv_m     ,   &   !   <<= in
+         &                sf(jp_qsr )%fnow(:,:,1) , sf(jp_qlw )%fnow(:,:,1) ,   &   !   <<= in
          &                zssq, zcd_du, zsen, zevp                          )       !   =>> out
   
Index: /NEMO/branches/2019/dev_ASINTER-01-05_merged/src/OCE/SBC/sbc_oce.F90
===================================================================
--- /NEMO/branches/2019/dev_ASINTER-01-05_merged/src/OCE/SBC/sbc_oce.F90	(revision 12014)
+++ /NEMO/branches/2019/dev_ASINTER-01-05_merged/src/OCE/SBC/sbc_oce.F90	(revision 12015)
@@ -116,4 +116,5 @@
    !! wndm is used compute surface gases exchanges in ice-free ocean or leads
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   wndm              !: wind speed module at T-point (=|U10m-Uoce|)  [m/s]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   rhoa              !: air density at "rn_zu" m above the sea       [kg/m3] !LB
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   qsr               !: sea heat flux:     solar                     [W/m2]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   qns    , qns_b    !: sea heat flux: non solar                     [W/m2]
@@ -159,4 +160,10 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   frq_m     !: mean (nn_fsbc time-step) fraction of solar net radiation absorbed in the 1st T level [-]
 
+   !!----------------------------------------------------------------------
+   !!                     Cool-skin/Warm-layer
+   !!----------------------------------------------------------------------
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   tsk       !: sea-surface skin temperature (used if ln_skin_cs==.true. .OR. ln_skin_wl==.true.)  [K] !LB
+
+   
    !! * Substitutions
 #  include "vectopt_loop_substitute.h90"
@@ -177,5 +184,5 @@
       !
       ALLOCATE( utau(jpi,jpj) , utau_b(jpi,jpj) , taum(jpi,jpj) ,     &
-         &      vtau(jpi,jpj) , vtau_b(jpi,jpj) , wndm(jpi,jpj) , STAT=ierr(1) ) 
+         &      vtau(jpi,jpj) , vtau_b(jpi,jpj) , wndm(jpi,jpj) , rhoa(jpi,jpj) , STAT=ierr(1) ) 
          !
       ALLOCATE( qns_tot(jpi,jpj) , qns  (jpi,jpj) , qns_b(jpi,jpj),        &
